/*
 * Copyright (c) 2005-2007 Obeo
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Obeo - initial API and implementation
 */

package fr.obeo.acceleo.chain.ui.popupMenus;

import java.lang.reflect.InvocationTargetException;

import org.eclipse.core.resources.IFile;
import org.eclipse.jface.action.IAction;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.ui.IObjectActionDelegate;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.PlatformUI;

import fr.obeo.acceleo.chain.ui.AcceleoChainUIMessages;
import fr.obeo.acceleo.chain.ui.AcceleoChainUiPlugin;
import fr.obeo.acceleo.gen.template.eval.LaunchManager;

/**
 * The action which launchs the current selected chain.
 * 
 * @author www.obeo.fr
 * 
 */
public class AcceleoChainLaunchAction implements IObjectActionDelegate {

	/**
	 * Selected chain file.
	 */
	protected ISelection selection;

	/**
	 * Constructor.
	 */
	public AcceleoChainLaunchAction() {
		super();
	}

	/* (non-Javadoc) */
	public void setActivePart(IAction action, IWorkbenchPart targetPart) {
	}

	/* (non-Javadoc) */
	public void run(IAction action) {
		try {
			IFile file = (IFile) ((StructuredSelection) selection).getFirstElement();
			AcceleoChainLaunchOperation operation = new AcceleoChainLaunchOperation(new IFile[] { file }, LaunchManager.create("run", true)); //$NON-NLS-1$
			PlatformUI.getWorkbench().getProgressService().run(true, true, operation);
		} catch (InvocationTargetException e) {
			AcceleoChainUiPlugin.getDefault().log(e, true);
		} catch (InterruptedException e) {
			AcceleoChainUiPlugin.getDefault().log(AcceleoChainUIMessages.getString("InterruptedOperation"), true); //$NON-NLS-1$
		}
	}

	/* (non-Javadoc) */
	public void selectionChanged(IAction action, ISelection selection) {
		this.selection = selection;
	}

}
