/*
 * Copyright (c) 2005-2007 Obeo
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Obeo - initial API and implementation
 */

package fr.obeo.acceleo.gen.ui.editors.template.scanner;

import org.eclipse.jface.text.TextAttribute;
import org.eclipse.jface.text.rules.Token;

import fr.obeo.acceleo.gen.ui.editors.template.ColorManager;

/**
 * A scanner for detecting comment sequences.
 * 
 * @author www.obeo.fr
 * 
 */
public class AcceleoTemplateCommentScanner extends AcceleoTemplateBasedScanner {

	/**
	 * Constructor.
	 * 
	 * @param manager
	 *            is the color manager
	 */
	public AcceleoTemplateCommentScanner(ColorManager manager) {
		setDefaultReturnToken(new Token(new TextAttribute(manager.getColor(IAcceleoTemplateColorConstants.COMMENT))));
	}

	/* (non-Javadoc) */
	public String getConfiguredContentType() {
		return AcceleoTemplatePartitionScanner.TEMPLATE_COMMENT;
	}

}
