/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml14.behavioral_elements.use_cases;

import org.eclipse.emf.common.util.EList;

import fr.obeo.acceleo.uml14.foundation.core.Classifier;

/**
 * <!-- begin-user-doc --> A representation of the model object '<em><b>Use Case</b></em>'.
 * <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>{@link fr.obeo.acceleo.uml14.behavioral_elements.use_cases.UseCase#getExtender <em>Extender</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml14.behavioral_elements.use_cases.UseCase#getExtend <em>Extend</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml14.behavioral_elements.use_cases.UseCase#getIncluder <em>Includer</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml14.behavioral_elements.use_cases.UseCase#getInclude <em>Include</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml14.behavioral_elements.use_cases.UseCase#getExtensionPoint <em>Extension Point</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.obeo.acceleo.uml14.behavioral_elements.use_cases.Use_casesPackage#getUseCase()
 * @model
 * @generated
 */
public interface UseCase extends Classifier {
	/**
	 * Returns the value of the '<em><b>Extender</b></em>' reference list.
	 * The list contents are of type
	 * {@link fr.obeo.acceleo.uml14.behavioral_elements.use_cases.Extend}. It
	 * is bidirectional and its opposite is '{@link fr.obeo.acceleo.uml14.behavioral_elements.use_cases.Extend#getBase <em>Base</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Extender</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Extender</em>' reference list.
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.use_cases.Use_casesPackage#getUseCase_Extender()
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.use_cases.Extend#getBase
	 * @model type="fr.obeo.acceleo.uml14.behavioral_elements.use_cases.Extend"
	 *        opposite="base"
	 * @generated
	 */
	EList getExtender();

	/**
	 * Returns the value of the '<em><b>Extend</b></em>' reference list.
	 * The list contents are of type
	 * {@link fr.obeo.acceleo.uml14.behavioral_elements.use_cases.Extend}. It
	 * is bidirectional and its opposite is '{@link fr.obeo.acceleo.uml14.behavioral_elements.use_cases.Extend#getExtension <em>Extension</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Extend</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Extend</em>' reference list.
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.use_cases.Use_casesPackage#getUseCase_Extend()
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.use_cases.Extend#getExtension
	 * @model type="fr.obeo.acceleo.uml14.behavioral_elements.use_cases.Extend"
	 *        opposite="extension"
	 * @generated
	 */
	EList getExtend();

	/**
	 * Returns the value of the '<em><b>Includer</b></em>' reference list.
	 * The list contents are of type
	 * {@link fr.obeo.acceleo.uml14.behavioral_elements.use_cases.Include}. It
	 * is bidirectional and its opposite is '{@link fr.obeo.acceleo.uml14.behavioral_elements.use_cases.Include#getAddition <em>Addition</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Includer</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Includer</em>' reference list.
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.use_cases.Use_casesPackage#getUseCase_Includer()
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.use_cases.Include#getAddition
	 * @model type="fr.obeo.acceleo.uml14.behavioral_elements.use_cases.Include"
	 *        opposite="addition"
	 * @generated
	 */
	EList getIncluder();

	/**
	 * Returns the value of the '<em><b>Include</b></em>' reference list.
	 * The list contents are of type
	 * {@link fr.obeo.acceleo.uml14.behavioral_elements.use_cases.Include}. It
	 * is bidirectional and its opposite is '{@link fr.obeo.acceleo.uml14.behavioral_elements.use_cases.Include#getBase <em>Base</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Include</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Include</em>' reference list.
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.use_cases.Use_casesPackage#getUseCase_Include()
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.use_cases.Include#getBase
	 * @model type="fr.obeo.acceleo.uml14.behavioral_elements.use_cases.Include"
	 *        opposite="base"
	 * @generated
	 */
	EList getInclude();

	/**
	 * Returns the value of the '<em><b>Extension Point</b></em>'
	 * containment reference list. The list contents are of type
	 * {@link fr.obeo.acceleo.uml14.behavioral_elements.use_cases.ExtensionPoint}.
	 * It is bidirectional and its opposite is '{@link fr.obeo.acceleo.uml14.behavioral_elements.use_cases.ExtensionPoint#getUseCase <em>Use Case</em>}'.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Extension Point</em>' containment
	 * reference list isn't clear, there really should be more of a description
	 * here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Extension Point</em>' containment
	 *         reference list.
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.use_cases.Use_casesPackage#getUseCase_ExtensionPoint()
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.use_cases.ExtensionPoint#getUseCase
	 * @model type="fr.obeo.acceleo.uml14.behavioral_elements.use_cases.ExtensionPoint"
	 *        opposite="useCase" containment="true"
	 * @generated
	 */
	EList getExtensionPoint();

} // UseCase
